// DISPSTR.CPP - Implementation file for your Internet Server
//    Display a string from the client.

#include "stdafx.h"
#include "DispStr.h"

///////////////////////////////////////////////////////////////////////
// The one and only CWinApp object
// NOTE: You may remove this object if you alter your project to no
// longer use MFC in a DLL.

CWinApp theApp;

///////////////////////////////////////////////////////////////////////
// command-parsing map

BEGIN_PARSE_MAP(CDispStrExtension, CHttpServer)
	// Our special DisplayStr parse command.
	ON_PARSE_COMMAND(DisplayStr, CDispStrExtension, ITS_PSTR)
	ON_PARSE_COMMAND_PARAMS("string='No String Supplied'")

	// Default parse command
	ON_PARSE_COMMAND(Default, CDispStrExtension, ITS_EMPTY)
	DEFAULT_PARSE_COMMAND(Default, CDispStrExtension)
END_PARSE_MAP(CDispStrExtension)


///////////////////////////////////////////////////////////////////////
// The one and only CDispStrExtension object

CDispStrExtension theExtension;


///////////////////////////////////////////////////////////////////////
// CDispStrExtension implementation

CDispStrExtension::CDispStrExtension()
{
}

CDispStrExtension::~CDispStrExtension()
{
}

BOOL CDispStrExtension::GetExtensionVersion(HSE_VERSION_INFO* pVer)
{
	// Call default implementation for initialization
	CHttpServer::GetExtensionVersion(pVer);

	// Load description string
	TCHAR sz[HSE_MAX_EXT_DLL_NAME_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_SERVER, sz, HSE_MAX_EXT_DLL_NAME_LEN));
	_tcscpy(pVer->lpszExtensionDesc, sz);
	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// CDispStrExtension command handlers

void CDispStrExtension::Default(CHttpServerContext* pCtxt)
{
	StartContent(pCtxt);
	WriteTitle(pCtxt);

	*pCtxt << _T("This default message was produced by the Internet");
	*pCtxt << _T(" Server DLL Wizard. Edit your CDispStrExtension::Default()");
	*pCtxt << _T(" implementation to change it.\r\n");

	EndContent(pCtxt);
}

void CDispStrExtension::DisplayStr(CHttpServerContext* pCtxt, LPTSTR pszString)
{
	// Start sending information to the new Web page including a default title.
	StartContent(pCtxt);
	WriteTitle(pCtxt);

	// Display the body of the new page.
	*pCtxt << _T("<H3><CENTER>ISAPI Server Extension Example</CENTER></H3><P><P>");
	*pCtxt << _T("This was the string you entered:<P><EM>");
	*pCtxt << _T(pszString);
	*pCtxt << _T("</EM>");

	// End the dipslay area.
	EndContent(pCtxt);
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CDispStrExtension, CHttpServer)
	//{{AFX_MSG_MAP(CDispStrExtension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0



///////////////////////////////////////////////////////////////////////
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments arounn the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

/****

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}

****/
